| http://www.sim.no/ http://www.coin3d.org/

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | List of all members
SoGetMatrixAction Class Reference
Action Classes

The SoGetMatrixAction class is an action for accumulating the transformation matrix of a subgraph.This action makes it easy to calculate and convert to and from the global coordinate system of your scene and local coordinates of parts in a hierarchical model. More...

`#include <Inventor/actions/SoGetMatrixAction.h>`

Inheritance diagram for SoGetMatrixAction:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoGetMatrixAction (const SbViewportRegion &region)
virtual | ~SoGetMatrixAction (void)
void | setViewportRegion (const SbViewportRegion &region)
const SbViewportRegion & | getViewportRegion (void) const
SbMatrix & | getMatrix (void)
SbMatrix & | getInverse (void)
SbMatrix & | getTextureMatrix (void)
SbMatrix & | getTextureInverse (void)
Public Member Functions inherited from SoAction
virtual | ~SoAction (void)
virtual SbBool | isOfType (SoType type) const
virtual void | apply (SoNode *root)
virtual void | apply (SoPath *path)
virtual void | apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
void | apply (SoAction *beingApplied)
virtual void | invalidateState (void)
AppliedCode | getWhatAppliedTo (void) const
SoNode * | getNodeAppliedTo (void) const
SoPath * | getPathAppliedTo (void) const
const SoPathList * | getPathListAppliedTo (void) const
const SoPathList * | getOriginalPathListAppliedTo (void) const
SbBool | isLastPathListAppliedTo (void) const
PathCode | getPathCode (int &numindices, const int *&indices)
void | traverse (SoNode *const node)
SbBool | hasTerminated (void) const
const SoPath * | getCurPath (void)
SoState * | getState (void) const
PathCode | getCurPathCode (void) const
virtual SoNode * | getCurPathTail (void)
void | usePathCode (int &numindices, const int *&indices)
void | pushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (const PathCode prevpathcode)
void | pushCurPath (void)
void | popPushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (void)
void | switchToPathTraversal (SoPath *path)
void | switchToNodeTraversal (SoNode *node)

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
Static Public Member Functions inherited from SoAction
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)
static void | nullAction (SoAction *action, SoNode *node)

## Protected Member Functions

virtual const SoEnabledElementsList & | getEnabledElements (void) const
virtual void | beginTraversal (SoNode *node)
Protected Member Functions inherited from SoAction
| SoAction (void)
virtual void | endTraversal (SoNode *node)
void | setTerminated (const SbBool flag)
virtual SbBool | shouldCompactPathList (void) const

## Static Protected Member Functions

static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)

## Additional Inherited Members

Public Types inherited from SoAction
enum | AppliedCode { NODE = 0, PATH = 1, PATH_LIST = 2 }
enum | PathCode { NO_PATH = 0, IN_PATH = 1, BELOW_PATH = 2, OFF_PATH = 3 }
Protected Attributes inherited from SoAction
SoState * | state
SoActionMethodList * | traversalMethods

## Detailed Description

The SoGetMatrixAction class is an action for accumulating the transformation matrix of a subgraph.

This action makes it easy to calculate and convert to and from the global coordinate system of your scene and local coordinates of parts in a hierarchical model.

As opposed to most other action types, the SoGetMatrixAction does not traverse children of the node it is applied to – just the node itself. When applied to paths, it stops at the last node and does not continue further with the children of the tail node.

Typical usage when querying for world space position, orientation and/or scaling would be as follows:

// First get hold of an SoPath through the scenegraph down to the
// node ("mynode") you want to query about its current world space
// transformation(s).
SoSearchAction * searchaction = new SoSearchAction;
searchaction->setNode(mynode);
searchaction->apply(myscenegraphroot);
SoPath * path = searchaction->getPath();
assert(path != NULL);
// Then apply the SoGetMatrixAction to get the full transformation
// matrix from world space.
const SbViewportRegion vpr = myviewer->getViewportRegion();
SoGetMatrixAction * getmatrixaction = new SoGetMatrixAction(vpr);
getmatrixaction->apply(path);
SbMatrix transformation = getmatrixaction->getMatrix();
// And if you want to access the individual transformation
// components of the matrix:
SbVec3f translation;
SbRotation rotation;
SbVec3f scalevector;
SbRotation scaleorientation;
transformation.getTransform(translation, rotation, scalevector, scaleorientation);

## Constructor & Destructor Documentation

## ◆ SoGetMatrixAction()

SoGetMatrixAction::SoGetMatrixAction | ( | const SbViewportRegion & | region | ) |

Constructor.

The region viewport specification is not used by this action, and is passed along in case it is needed by any nodes.

## ◆ ~SoGetMatrixAction()

SoGetMatrixAction::~SoGetMatrixAction | ( | void |  | ) |

virtual

Destructor.

## Member Function Documentation

## ◆ getTypeId()

SoType SoGetMatrixAction::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an action derived from a class inheriting SoAction. This is used for run-time type checking and "downward" casting.

Usage example:

void bar(SoAction * action)
{
if (action->getTypeId() == SoGLRenderAction::getClassTypeId()) {
// safe downward cast, know the type
SoGLRenderAction * glrender = (SoGLRenderAction *)action;
}
return; // ignore if not renderaction
}

For application programmers wanting to extend the library with new actions: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through Inventor/nodes/SoSubAction.h: SO_ACTION_SOURCE, SO_ACTION_INIT_CLASS and SO_ACTION_CONSTRUCTOR.

For more information on writing Coin extensions, see the SoAction class documentation.

Returns the actual type id of an object derived from a class inheriting SoAction. Needs to be overridden in all subclasses.

Implements SoAction.

## ◆ addMethod()

void SoGetMatrixAction::addMethod | ( | const SoType | type,
|  | SoActionMethod | method
| ) |  |

static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ enableElement()

void SoGetMatrixAction::enableElement | ( | const SoType | type,
|  | const int | stackindex
| ) |  |

static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ getEnabledElements()

const SoEnabledElementsList & SoGetMatrixAction::getEnabledElements | ( | void |  | ) | const

protectedvirtual

Returns a list of the elements used by action instances of this class upon traversal operations.

Reimplemented from SoAction.

## ◆ setViewportRegion()

void SoGetMatrixAction::setViewportRegion | ( | const SbViewportRegion & | region | ) |

Set the viewport region.

See also
  SoGetMatrixAction::SoGetMatrixAction()

## ◆ getViewportRegion()

const SbViewportRegion & SoGetMatrixAction::getViewportRegion | ( | void |  | ) | const

Returns the viewport region for the action instance.

## ◆ getMatrix()

SbMatrix & SoGetMatrixAction::getMatrix | ( | void |  | ) |

Returns the accumulated transformation matrix.

Note: don't modify the returned matrix. This should only be done if you are implementing your own transformation type node extensions. This advice is also valid for the other matrix access methods documented below.

## ◆ getInverse()

SbMatrix & SoGetMatrixAction::getInverse | ( | void |  | ) |

Returns the inverse of the accumulated transformation matrix.

## ◆ getTextureMatrix()

SbMatrix & SoGetMatrixAction::getTextureMatrix | ( | void |  | ) |

Returns the accumulated texture matrix.

## ◆ getTextureInverse()

SbMatrix & SoGetMatrixAction::getTextureInverse | ( | void |  | ) |

Returns the inverse of the accumulated texture matrix.

## ◆ beginTraversal()

void SoGetMatrixAction::beginTraversal | ( | SoNode * | node | ) |

protectedvirtual

This virtual method is called from SoAction::apply(), and is the entry point for the actual scenegraph traversal.

It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction.

Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scenegraph traversal.

Reimplemented from SoAction.

The documentation for this class was generated from the following files:

- SoGetMatrixAction.h
- SoGetMatrixAction.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.